#include<bits/stdc++.h>
using namespace std;

int s,n,a[2005],p[20005],h[20005];

int f(int g){
    if(g==0){
        return 0;
    }
    int mig=100000;
    if(h[g]==0){
        for(int j=0;j<n;j++){
            if(g-a[j]>=0){
                mig=min(mig,f(g-a[j]));
            }
        }
        //cout<<mig+1<<endl;
        h[g]=mig+1;
        return mig+1;
    }else{
        return h[g];
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>s>>n;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    sort(a,a+n);
    cout<<f(s)<<endl;
    /*
    for(int i=0;i<=1000;i++){
        if(h[i]!=0){
            cout<<i<<" "<<h[i]<<endl;
        }
    }
    */
    return 0;
}
